/*  $Id: cd_drive_generic.h,v 1.5 2004/02/01 20:28:56 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#ifndef header_cd_drive_generic
#define header_cd_drive_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include <string>

class CL_CDDrive_Generic
{
//! Construction:
public:
	CL_CDDrive_Generic() { return; }
	
	virtual ~CL_CDDrive_Generic() { return; }

//! Attributes:
public:
	virtual std::string get_drive_path() = 0;

	virtual std::string get_cd_name() = 0;

	virtual int get_num_tracks() = 0;

	virtual bool is_playing() = 0;
	
	virtual int get_cur_track() = 0;

	virtual int get_cur_frame() = 0;

//! Operations:
public:
	virtual bool play_tracks(int track, int end_track) = 0;

	virtual bool play_frames(int frame, int end_frame) = 0;

	virtual bool play_track(int track) = 0;

	virtual void stop() = 0;

	virtual void pause() = 0;

	virtual void resume() = 0;

//! Implementation:
private:
};

#endif
